﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Media;

namespace AsyncLibrary
{
    public class LinkInfo : INotifyPropertyChanged
    {
        private string _title;
        public string Title
        {
            get { return _title; }
            set { _title = value; RaisePropertyChanged("Title"); }
        }

        private string _html;
        public string Html
        {
            get { return _html; }
            set { _html = value; RaisePropertyChanged("Html"); }
        }

        private int _length;
        public int Length
        {
            get { return _length; }
            set { _length = value; RaisePropertyChanged("Length"); }
        }

        private Color _color;
        public Color Color
        {
            get { return _color; }
            set { _color = value; RaisePropertyChanged("Color"); }
        }

        public event PropertyChangedEventHandler PropertyChanged;
        protected virtual void RaisePropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }
}
