﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Project_1
{
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            List<string> uris = new List<string>();
            btnDoWork.IsEnabled = false;

            txtHtml.Text = "";
            lstLinks.ItemsSource = null;

            try
            {
                string result = new WebClient().DownloadString("http://msdn.microsoft.com/");
                txtHtml.Text = result;

                MatchCollection mc = Regex.Matches(result, "href\\s*=\\s*(?:\"(?<1>http://[^\"]*)\")", RegexOptions.IgnoreCase);
                foreach (Match m in mc)
                {
                    uris.Add(m.Groups[1].Value);
                }
                lstLinks.ItemsSource = uris;
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }

            btnDoWork.IsEnabled = true;
        }

        private void Button_Click_2(object sender, RoutedEventArgs e)
        {
            List<string> uris = new List<string>();
            btnDoWork_Sample.IsEnabled = false;

            txtHtml.Text = "";
            lstLinks.ItemsSource = null;

            try
            {
                WebClient client = new WebClient();
                client.DownloadStringCompleted += (completedSender, completedE) =>
                {
                    if (completedE.Error != null)
                    {
                        ResultCallback(null, null, completedE.Error);
                    }
                    else
                    {
                        MatchCollection mc = Regex.Matches(completedE.Result, "href\\s*=\\s*(?:\"(?<1>http://[^\"]*)\")", RegexOptions.IgnoreCase);
                        foreach (Match m in mc)
                        {
                            uris.Add(m.Groups[1].Value);
                        }
                        ResultCallback(completedE.Result, uris, null);
                    }
                };

                client.DownloadStringAsync(new Uri("http://msdn.microsoft.com/"));
            }
            catch { }

            btnDoWork_Sample.IsEnabled = true;
        }

        private void ResultCallback(string result, List<string> uris, Exception ex)
        {
            if (ex == null)
            {
                txtHtml.Text = result;
                lstLinks.ItemsSource = uris;
            }
        }
    }
}
