﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Net;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Project_3
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private async void Button_Click(object sender, RoutedEventArgs e)
        {
            ObservableCollection<string> uris = new ObservableCollection<string>();
            btnDoWork.IsEnabled = false;

            txtHtml.Text = "";
            lstLinks.ItemsSource = null;

            try
            {
                string result = await new WebClient().DownloadStringTaskAsync("http://msdn.microsoft.com/");
                txtHtml.Text = result;

                await Task.Run(() =>
                {
                    MatchCollection mc = Regex.Matches(result, "href\\s*=\\s*(?:\"(?<1>http://[^\"]*)\")", RegexOptions.IgnoreCase);
                    foreach (Match m in mc)
                    {
                        uris.Add(m.Groups[1].Value);
                    }
                });
                LinkInfo[] links = await Task.WhenAll(from uri in uris select DownloadItem(uri));
                lstLinks.ItemsSource = links;
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }

            btnDoWork.IsEnabled = true;
        }

        public async Task<LinkInfo> DownloadItem(string uri)
        {
            string item = await new WebClient().DownloadStringTaskAsync(uri);
            LinkInfo link = await Task.Run(() => new LinkInfo { Length = item.Length, Html = item, Title = GetTitle(item) });
            return link;
        }

        public string GetTitle(string html)
        {
            Match m = Regex.Match(html, @"(?<=<title.*>)([\s\S]*)(?=</title>)", RegexOptions.IgnoreCase);
            return m.Value;
        }
    }
}
